# pkg> activate KhovanskiiSolving 
using KhovanskiiSolving 
using Oscar
using LinearAlgebra

d = 2
p = 9716633; 
K = GF(p); 

R, (t1,t2) = PolynomialRing(K, ["t1";"t2"]) 
φ = [t1-t2; t2^2-t2; t1*t2-t2; t1^2-t2; t1*t2^2-t2; t1^2*t2-t2]; 
S, x = PolynomialRing(K, ["x$i" for i = 1:length( φ)]) ;
evs = collect(exponents(sum(x)^d)); mons = [prod(φ.^ev) for ev in evs] ;
c1 = rand(1:p,length(mons)); c2 = rand(1:p,length(mons)) ;
f1 = (c1'*mons); f2 = (c2'*mons) ;
degs_f = [d;d]; 

dreg = sum(degs_f)+1; 

leadexps = [leadexp(h,[-2;-1]) for h in φ]
Mul = @time get_commuting_matrices([f1;f2],dreg,degs_f,φ,K,(t1,t2),leadexps);
size(Mul[1]) 

