
# pkg> activate KhovanskiiSolving 
using KhovanskiiSolving 
using Oscar
using LinearAlgebra

k=2
m=5
n=k*(m-k)
varstring = ["t$i" for i=1:n]
K = QQ;

#construct the osculating flags
var_t=["t"]
S, t = PolynomialRing(K, var_t)
t=t[1]
γ=[t^i for i=0:m-1]
osc = [[γ]]
for i = 1:2 
	push!(osc,[derivative.(osc[end][1],1)])
end
osc
Flags=[]
α=[3,5] 
codimSchubertVariety(α,k,m) 
s= [1; -1; 2; -2; 3; -3]
for l=1:length(s)
	M=transpose(hcat(vcat(osc...)...))
	N1=[ Oscar.evaluate(M[i,j], [ K(s[l]) ])  for i=1:size(M,1) for j=1:size(M,2) ]
	N=transpose((reshape(N1,size(M,2),size(M,1))))
	push!(Flags,N)
end
length(Flags) #6

R, t = PolynomialRing(K, varstring);
vrs = t;

MS = MatrixSpace(R,k,m);
M = Int64.(diagm(ones(k))).+0*t[1] 
M = R.(hcat(M, reshape(t,k,m-k)))
ϕ = minors(MS(M),k);
w = [-1 for i=1:length(vrs)];
leadexps = [leadexp(hh,w) for hh in ϕ];

MS1=MatrixSpace(R,k,k)
F=[]
for i=1:length(α)
	if k+α[i]-i+1 <=minimum([m,k+α[i]])
		MSi=MatrixSpace(R,k+α[i],m)
		for j=1:length(Flags)
    		push!(F, minors( MSi( vcat(M,Flags[j][[i for i=1:α[i]],:])), k+α[i]-i+1) );
		end
	end
end
F=unique(vcat(F...));
length(F) # 6
degs_F=[1 for i=1:length(F)];

dreg=sum(degs_F)+ (-m+1)+1
@time KM = get_KM(F,dreg,degs_F,ϕ,K,vrs,leadexps);

Mul = @time get_commuting_matrices(F,dreg,degs_F,ϕ,K,vrs,leadexps);
get_solutions(Mul)

sols = solve_Khovanskii(F,dreg,degs_F,ϕ,vrs,leadexps);
sols = sols./sols[:,1] #normalized solutions

real_sol = get_real_solutions(Mul; tol = 1e-10);

